# coding=utf-8
# """
# @Author: JokerMa
# @Eamil: mazhiguo@kylinos.com.cn
# @Time: 2020.12
# @Instruction: provides functions to handle repair log.
# """
import os
import gettext
from settings import CUSTOM_DEL_LOG, CUSTOM_ADD_LOG, CUSTOM_VERSION_DIFFER


# i18n
gettext.install("kylinrepair", "/usr/share/locale")


def rm_old_log():
    """ remove old log file """
    try:
        os.remove(CUSTOM_ADD_LOG)
    except:
        pass
    try:
        os.remove(CUSTOM_DEL_LOG)
    except:
        pass
    try:
        os.remove(CUSTOM_VERSION_DIFFER)
    except:
        pass


def report(logfile, opt):
    """ report information """
    if not os.path.exists(logfile):
        return -1
    opt_dic = {
        "add": _("\nThe following RPM packages are not pre installed："),
        "del": _("\nThe following pre installed RPM packages were uninstalled："),
        "changed": _("\nThe following RPM packages have been overridden and installed as a different version：")
    }
    print(opt_dic.get(opt) + "saved in file %s"%logfile)
