#!/usr/bin/env python3
# coding:utf-8
# """
# @Author: JokerMa
# @Eamil: mazhiguo@kylinos.com.cn
# @Time: 2020.12
# @Instruction: entry of kylin-repair.
# """

import os
import gettext
from settings import CUSTOM_ADD_LOG, CUSTOM_VERSION_DIFFER, CUSTOM_DEL_LOG, RPM_INFO_JSONF, CHROOT_PATH, CD_REPO_PATH
from KySystemRepair import SystemRepair
from utils import quit_judge
from logutils import report, rm_old_log
from repohandle import repo_config, repo_recover
from save_rpm_info import rpm_info_save_json

# i18n
gettext.install("kylinrepair", "/usr/share/locale")


def main():
    operation1 = input(_("Please select the action option!\n1. System inspection report\n2. System inspection and repair\n3. Reinstall all pre installed RPMS\n4. Store current environment RPM list\n5. exit\n> "))
    quit_judge(operation1)

    if operation1 in ['1', '2', '3', '4']:
        while True:
            root_path = input(_("Please input the root path(default '/mnt/sysimage/'): "))
            quit_judge(root_path)
            if root_path == "":
                root_path = CHROOT_PATH
                break
            elif not os.path.exists(root_path):
                print(_("Path does not exists!"))
            else:
                break
        sr = SystemRepair(root_path=root_path)

    repo_path = ""
    if operation1 in ['2', '3']:
        while True:
            repo_path = input(_("Please input the repo path(default: 'file:///mnt/install/repo/'): ")).replace(" ", "")
            quit_judge(repo_path)
            if repo_path == "":
                repo_path = CD_REPO_PATH
                break
            elif not (repo_path.startswith("file:///") or repo_path.startswith("http://") or repo_path.startswith("https://")):
                print(_("Please input repo path (file:///example) or http(s) path (http(s)://example)!"))
            else:
                break

    if operation1 == "1":
        rm_old_log()
        sr.info_diff("check")
        report(CUSTOM_DEL_LOG, "del")
        report(CUSTOM_ADD_LOG, "add")
        report(CUSTOM_VERSION_DIFFER, "changed")
        print("Done!")
    elif operation1 == "2":
        repo_config(root_path=root_path, repo_path=repo_path)
        rm_old_log()
        sr.info_diff("handle")
        repo_recover(root_path=root_path)
        print("Done!")
    elif operation1 == "3":
        repo_config(root_path=root_path, repo_path=repo_path)
        rm_old_log()
        sr.info_diff("handle_all")
        repo_recover(root_path=root_path)
        print("Done!")
    elif operation1 == "4":
        rpm_info_save_json(root_path)
        print(_("\nJson file saved to path：%s" % root_path + RPM_INFO_JSONF))
    else:
        print("Exit！")


if __name__ == '__main__':
    main()
