# coding:utf-8
# """
# @Author: JokerMa
# @Eamil: mazhiguo@kylinos.com.cn
# @Time: 2020.12
# @Instruction: provides linux command encapsulation.
# """

import subprocess
from settings import CHROOT_PATH, REPEAT_RPM


def call_cmd(cmd):
    sub = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE, stdin=subprocess.PIPE)
    stdout, stderr = sub.communicate()
    ret = sub.returncode
    ret_dic = {"stdout": stdout, "stderr": stderr, "ret": ret}
    return ret_dic


def get_rpm_list(tg_path=""):
    if not tg_path:
        tg_path = CHROOT_PATH
    cmd = "rpm -qa --root=%s| sort" % tg_path
    retDic = call_cmd(cmd)
    stdout, stderr, ret = retDic["stdout"].decode('utf-8'), retDic["stderr"].decode('utf-8'), retDic["ret"]
    if ret == 0:
        pr_list = []
        repeat_list = []
        for rpm in stdout.split("\n"):
            if rpm not in pr_list:
                pr_list.append(rpm)
            else:
                repeat_list.append(rpm)
        if repeat_list:
            with open(REPEAT_RPM, "w") as repeat_f:
                for item in repeat_list:
                    repeat_f.write(item+"\n")
            print(_("There are some repeted RPMs in the filesystem,logged in %s,maybe you want to reinstall it!") %
                  REPEAT_RPM)
        return pr_list
    else:
        print(stderr)
        return ""


def get_rpm_info(itype, rpm_name, tg_path=""):
    if not tg_path:
        tg_path = CHROOT_PATH
    itype_list = ["name", "version", "release"]
    if itype not in itype_list:
        return ""
    if itype == "name":
        cmd = "rpm -qi '%s' --root=%s |grep '^Name'|awk -F: '{print $2}' | head -n 1" % (rpm_name, tg_path)
    elif itype == "version":
        cmd = "rpm -qi '%s' --root=%s |grep '^Version'|awk -F: '{print $2}' | head -n 1" % (rpm_name, tg_path)
    elif itype == "release":
        cmd = "rpm -qi '%s' --root=%s |grep '^Release'|awk -F: '{print $2}' | head -n 1" % (rpm_name, tg_path)
    else:
        return ""
    retDic = call_cmd(cmd)
    stdout, stderr, ret = retDic["stdout"].decode('utf-8'), retDic["stderr"].decode('utf-8'), retDic["ret"]
    if ret == 0:
        return stdout.strip()
    else:
        print(stderr)
        return ""
