# coding:utf-8
# """
# @Author: JokerMa
# @Eamil: mazhiguo@kylinos.com.cn
# @Time: 2020.12
# @Instruction: RPM reinstall.Is is abandoned.
# """
import os
import json
import gettext
from settings import CHROOT_PATH, CD_REPO_PATH, CH_RPMINFO_JSON
from utils import progress, quit_judge, yes_or_no
from oscmd import call_cmd

# i18n
gettext.install("kylinrepair", "/usr/share/locale")


def rpm_reinstall_pkg(opt, pkgnvr):
    cmd = "rpm %s --root=%s %s/Packages/%s" % (opt, CHROOT_PATH, CD_REPO_PATH, pkgnvr)
    ret_dic = call_cmd(cmd)
    ret = ret_dic['ret']
    return ret


def rpm_reinstall_all(pkgs_list):
    cnt = 0
    total = len(pkgs_list)
    f3 = open("/var/log/reinstall_fail.log", "w")
    for pkg in pkgs_list:
        ret_up = rpm_reinstall_pkg("-Uvh --nodeps --force", pkg)
        if ret_up != 0:
            f3.write("pkg\n")
        cnt += 1
        progress(100 * cnt / total)
    f3.close()


def pre_reinstall_all():
    sure_to_reinst = input(_("Do you want to reinstall all the RPMS?(yes/no)\n> "))
    quit_judge(sure_to_reinst)
    if yes_or_no(sure_to_reinst) == 1:
        retDict = call_cmd("arch")
        arch = retDict['stdout'].replace("\n", "")
        with open(CH_RPMINFO_JSON, "r") as f1:
            allpkgs = f1.read()
        json_pkgs = json.loads(allpkgs)
        pkgs_list = []
        for n, vr in json_pkgs.items():
            nvr = n + "-" + vr['ver'] + "-" + vr['rel']
            nvr1p = nvr + "." + arch + ".rpm"
            nvr2p = nvr + ".noarch.rpm"
            if os.path.exists(CD_REPO_PATH+"/Packages/"+nvr1p):
                pkgs_list.append(nvr1p)
            elif os.path.exists(CD_REPO_PATH+"/Packages/"+nvr2p):
                pkgs_list.append(nvr2p)
            else:
                pkgs_list.append(nvr)
        rpm_reinstall_all(pkgs_list)
    else:
        print("NOT TO REINSTALL!")
        exit(0)
