# coding:utf-8
# """
# @Author: JokerMa
# @Eamil: mazhiguo@kylinos.com.cn
# @Time: 2020.12
# @Instruction: handle the repo in the root path temporarily for repair.
# """
import os
import shutil
import gettext
from settings import REPO, REPO_BACK

# i18n
gettext.install("kylinrepair", "/usr/share/locale")


def repo_config(root_path, repo_path):
    """ yum repo config"""
    repo_text = """
[repair]
name=UniKylin-$releasever - Repair
gpgcheck=0
baseurl=%s
gpgkey=file:///etc/pki/rpm-gpg/RPM-GPG-KEY-kylin-release
        """ % repo_path
    os.system("dnf clean all")
    shutil.move(root_path+REPO, root_path+REPO_BACK)
    os.mkdir(root_path+REPO)
    with open(root_path+REPO + "/Kylin-Repair.repo", "w") as f:
        f.write(repo_text)
    os.system("dnf clean all --installroot=%s & dnf makecache --installroot=%s" % (root_path, root_path))


def repo_recover(root_path):
    """ umount CD repo """
    os.system("dnf clean all --installroot=%s" % root_path)
    shutil.rmtree(root_path+REPO)
    shutil.move(root_path+REPO_BACK, root_path+REPO)
