# coding: utf-8
# """
# @Author: JokerMa
# @Eamil: mazhiguo@kylinos.com.cn
# @Time: 2020.12
# @Instruction: provides save rpm information API.
# """

import json
import gettext
from utils import progress
from oscmd import get_rpm_list, get_rpm_info
from settings import RPM_INFO_JSONF

# i18n
gettext.install("kylinrepair", "/usr/share/locale")


def rpm_info_save_json(tg_path=""):
    """ save rpm info to json file """
    rpmlsit = get_rpm_list(tg_path=tg_path)
    total = len(rpmlsit)
    cnt = 0
    drpm = {}
    for rpm in rpmlsit:
        rname = get_rpm_info("name", rpm, tg_path=tg_path).strip()
        rversion = get_rpm_info("version", rpm, tg_path=tg_path).strip()
        rrelease = get_rpm_info("release", rpm, tg_path=tg_path).strip()
        if rname and rversion and rrelease:
            drpm[rname] = {"ver": rversion, "rel": rrelease}
            cnt += 1
            progress(100 * cnt / total)
        else:
            continue
    with open(tg_path + RPM_INFO_JSONF, "w") as f:
        f.write(json.dumps(drpm))
