# coding:utf-8
# """
# @Author: JokerMa
# @Eamil: mazhiguo@kylinos.com.cn
# @Time: 2020.12
# @Instruction: provides some utiles functions for kylin-repair.
# """

import os
import sys
import gettext
from settings import CHROOT_PATH


# i18n
gettext.install("kylinrepair", "/usr/share/locale")


def quit_judge(arg):
    if arg.lower() in ["exit", "quit", "q"]:
        print("Exit!")
        exit()


def yes_or_no(arg):
    """ yes/no judgement """
    if arg.lower() in ["yes", "y"]:
        return 1
    elif arg.lower() in ["no", "n"]:
        return 0
    else:
        return -1


def umount_cd_repo():
    """ umount CD repo """
    os.system("umount /mnt/")


def exit_chroot():
    """ exit chroot """
    os.system("exit")


def ch_root():
    os.chdir(CHROOT_PATH)
    try:
        os.chroot(CHROOT_PATH)
    except Exception as e:
        print(_("Failed to chroot！\n%s") % e)
        return -1
        exit()
    rm_old_log()
    return 0


def progress(percent, width=50):
    """ print the process  """
    if percent >= 100:
        percent = 100
    show_str = ('[%%-%ds]' % width) % (int(width * percent / 100) * "#")
    if sys.version > "3":
        print('\r%s %d%%' % (show_str, percent), end="")
    else:
        print('\r%s %d%%' % (show_str, percent))
